/*
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2020, 2021. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *
 */
"use strict";var __createBinding=this&&this.__createBinding||(Object.create?function(e,t,o,s){void 0===s&&(s=o),Object.defineProperty(e,s,{enumerable:!0,get:function(){return t[o]}})}:function(e,t,o,s){void 0===s&&(s=o),e[s]=t[o]}),__setModuleDefault=this&&this.__setModuleDefault||(Object.create?function(e,t){Object.defineProperty(e,"default",{enumerable:!0,value:t})}:function(e,t){e.default=t}),__importStar=this&&this.__importStar||function(e){if(e&&e.__esModule)return e;var t={};if(null!=e)for(var o in e)"default"!==o&&Object.prototype.hasOwnProperty.call(e,o)&&__createBinding(t,e,o);return __setModuleDefault(t,e),t},__awaiter=this&&this.__awaiter||function(e,t,o,s){return new(o||(o=Promise))((function(i,n){function r(e){try{u(s.next(e))}catch(e){n(e)}}function a(e){try{u(s.throw(e))}catch(e){n(e)}}function u(e){var t;e.done?i(e.value):(t=e.value,t instanceof o?t:new o((function(e){e(t)}))).then(r,a)}u((s=s.apply(e,t||[])).next())}))};Object.defineProperty(exports,"__esModule",{value:!0}),exports.AuthLogout=void 0;const constants_1=require("../../../constants"),imperative=__importStar(require("@zowe/imperative")),rest_1=require("../../../rest"),CoreUtils_1=require("../../../utils/CoreUtils");class AuthLogout{static expireToken(e,t,o){return __awaiter(this,void 0,void 0,(function*(){this.log.trace("AuthLogout.expireToken called."),imperative.ImperativeExpect.toNotBeNullOrUndefined(e,constants_1.ZosFilesMessages.missingSession.message),yield CoreUtils_1.apiVersionCheck(e,101);let s=[];const i=`${constants_1.ZosRestApiConstants.RESOURCE}${constants_1.ZosRestApiConstants.AUTHLOGOUT}`;this.log.debug("Endpoint: "+i);try{const n=CoreUtils_1.checkForToken(e);if(void 0===n)throw new imperative.ImperativeError({msg:constants_1.ZosApiMessages.jwtTokenNotFound.message});s=[n];const r=yield rest_1.RseRestClient.postExpectJSON(e,i,s);let a;if(null===r&&(e.ISession.type="basic",e.ISession.tokenType=void 0,e.ISession.tokenValue=void 0,o.tokenType=e.ISession.tokenType,o.tokenValue=e.ISession.tokenValue),void 0===t.arguments.rseProfile){a=(yield CoreUtils_1.getDefaultProfile()).name}else a=t.arguments.rseProfile;return yield CoreUtils_1.saveYaml(a,o),r}catch(t){if(void 0===e.ISession.tokenValue)throw this.log.error(constants_1.ZosApiMessages.jwtTokenNotFound.message),new imperative.ImperativeError({msg:constants_1.ZosApiMessages.jwtTokenNotFound.message});{const e=t;throw this.log.error(e.toString()),t}}}))}static get log(){return imperative.Logger.getAppLogger()}}exports.AuthLogout=AuthLogout;