/*
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2020, 2021. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *
 */
"use strict";var __awaiter=this&&this.__awaiter||function(e,s,t,i){return new(t||(t=Promise))((function(n,o){function r(e){try{c(i.next(e))}catch(e){o(e)}}function a(e){try{c(i.throw(e))}catch(e){o(e)}}function c(e){var s;e.done?n(e.value):(s=e.value,s instanceof t?s:new t((function(e){e(s)}))).then(r,a)}c((i=i.apply(e,s||[])).next())}))};Object.defineProperty(exports,"__esModule",{value:!0}),exports.CheckAddressSpace=void 0;const imperative_1=require("@zowe/imperative"),_1=require("."),constants_1=require("../../constants"),RseRestClient_1=require("../../rest/RseRestClient"),CoreUtils_1=require("../../utils/CoreUtils");class CheckAddressSpace{static getSystemInfo(e){return __awaiter(this,void 0,void 0,(function*(){this.log.trace("CheckAddressSpace.getSystemInfo called"),imperative_1.ImperativeExpect.toNotBeNullOrUndefined(e,constants_1.ZosFilesMessages.missingSession.message),yield CoreUtils_1.apiVersionCheck(e,105),yield this.zosExplVersionCheck(e);const s=`${constants_1.ZosRestApiConstants.RESOURCE}${constants_1.ZosRestApiConstants.SYSINFO}`;this.log.debug("Endpoint: "+s);const t=CoreUtils_1.setHeaders(e);return{success:!0,commandResponse:"",apiResponse:yield RseRestClient_1.RseRestClient.getExpectJSON(e,s,t)}}))}static getJobsInfo(e){return __awaiter(this,void 0,void 0,(function*(){this.log.trace("CheckAddressSpace.getSystemInfo called"),imperative_1.ImperativeExpect.toNotBeNullOrUndefined(e,constants_1.ZosFilesMessages.missingSession.message),yield CoreUtils_1.apiVersionCheck(e,105),yield this.zosExplVersionCheck(e);const s=`${constants_1.ZosRestApiConstants.RESOURCE}${constants_1.ZosRestApiConstants.JOBSINFO}`;this.log.debug("Endpoint: "+s);const t=CoreUtils_1.setHeaders(e);return{success:!0,commandResponse:"",apiResponse:yield RseRestClient_1.RseRestClient.getExpectJSON(e,s,t)}}))}static zosExplVersionCheck(e){return __awaiter(this,void 0,void 0,(function*(){const s=[3,2,0,16],t=yield _1.CheckStatus.getRseStatus(e),i=JSON.parse(JSON.stringify(t)).rse_version.split(".");if(i.length<s.length&&i.push("0"),i.length>0){let e=0;i.forEach(t=>{if(Number(t)<s[e])throw this.log.debug(constants_1.ZosApiMessages.unsupportedZosExpl.message),new imperative_1.ImperativeError({msg:constants_1.ZosApiMessages.unsupportedZosExpl.message});e++})}}))}static get log(){return imperative_1.Logger.getAppLogger()}}exports.CheckAddressSpace=CheckAddressSpace;