/*
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2020, 2021. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *
 */
/**
 * This interface defines the map option that can be sent into the upload uss directory function
 */
export interface IUploadMap {
    /**
     * The indicator to upload the data set in binary mode
     */
    binary?: boolean;
    /**
     * List of file names to be uploaded in binary or asci
     */
    fileNames: string[];
}
