/*
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2020, 2021. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *
 */
"use strict";var __awaiter=this&&this.__awaiter||function(e,s,t,o){return new(t||(t=Promise))((function(r,i){function n(e){try{u(o.next(e))}catch(e){i(e)}}function a(e){try{u(o.throw(e))}catch(e){i(e)}}function u(e){var s;e.done?r(e.value):(s=e.value,s instanceof t?s:new t((function(e){e(s)}))).then(n,a)}u((o=o.apply(e,s||[])).next())}))};Object.defineProperty(exports,"__esModule",{value:!0}),exports.RestBaseHandler=void 0;const imperative_1=require("@zowe/imperative"),api_1=require("../api"),RestSessionUtils_1=require("./RestSessionUtils"),auth_1=require("../api/methods/auth");class RestBaseHandler{process(e){return __awaiter(this,void 0,void 0,(function*(){let s;this.params=e;const t=e.profiles.get("rse",!1)||{};e.arguments.basePath=t.basePath;const o=yield api_1.ZoweCliProfiles.getInstance(),r=o.getDefaultProfile("base");r&&t.host&&r.profile.host!==t.host&&!t.tokenValue&&(s=RestSessionUtils_1.RestSessionUtils.createBasicRestSession(t),s=yield auth_1.AuthLogin.promptUserPass(s),e.arguments.user=s.ISession.user,e.arguments.password=s.ISession.password),t.tokenValue&&(t.user||t.password)&&(e.arguments.user=void 0,e.arguments.password=void 0);const i=RestSessionUtils_1.RestSessionUtils.createSessCfgFromArgs(e.arguments),n=yield imperative_1.ConnectionPropsForSessCfg.addPropsOrPrompt(i,e.arguments);s=new imperative_1.Session(n),s.ISession.tokenValue&&(s=yield o.checkProfileToken(s,this.params,t));try{const o=yield this.processWithSession(e,s,t);e.response.progress.endBar(),e.response.data.setObj(o)}catch(e){const s=e;if(r&&r.profile.tokenValue&&t.host&&t.host===r.profile.host&&s.toString().includes("401")){throw`This operation requires authentication.\n\nRSE REST API Error:\nRest API failure with HTTP(S) status 401\n\nToken is not valid or expired for profile ${r.name} of type ${r.type}.\n\nFor CLI usage, see \`zowe auth login apiml --help\``}throw e}}))}checkReturnCode(e){}}exports.RestBaseHandler=RestBaseHandler;