/*
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2020, 2021. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *
 */
"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.DatasetDefinition=void 0;const Download_options_1=require("../../Download.options"),strings=require("../../../-strings-/en").default.DOWNLOAD.ACTIONS.DATA_SET;exports.DatasetDefinition={name:"data-set",aliases:["ds"],summary:strings.SUMMARY,description:strings.DESCRIPTION,type:"command",handler:__dirname+"/Dataset.handler",profile:{optional:["rse"]},positionals:[{name:"dataSetName",description:strings.POSITIONALS.DATASETNAME,type:"string",required:!0}],options:[Download_options_1.DownloadOptions.volume,Download_options_1.DownloadOptions.file,Download_options_1.DownloadOptions.binary,Download_options_1.DownloadOptions.encoding,Download_options_1.DownloadOptions.extension,Download_options_1.DownloadOptions.mappingsFile].sort((o,n)=>o.name.localeCompare(n.name)),examples:[{description:strings.EXAMPLES.EX1,options:'"ibmuser.loadlib(main)" -f main.obj'},{description:strings.EXAMPLES.EX2,options:'"ibmuser.loadlib(main)" -b "./main.obj"'}]};