/*
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2020, 2021. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *
 */
"use strict";var __awaiter=this&&this.__awaiter||function(e,s,t,a){return new(t||(t=Promise))((function(n,r){function i(e){try{p(a.next(e))}catch(e){r(e)}}function o(e){try{p(a.throw(e))}catch(e){r(e)}}function p(e){var s;e.done?n(e.value):(s=e.value,s instanceof t?s:new t((function(e){e(s)}))).then(i,o)}p((a=a.apply(e,s||[])).next())}))};Object.defineProperty(exports,"__esModule",{value:!0});const imperative_1=require("@zowe/imperative"),List_1=require("../../../../api/methods/list/List"),RestBaseHandler_1=require("../../../RestBaseHandler"),constants_1=require("../../../../api/constants");class AllMembersHandler extends RestBaseHandler_1.RestBaseHandler{processWithSession(e,s,t){return __awaiter(this,void 0,void 0,(function*(){imperative_1.Logger.getAppLogger().debug("AllMembersHandler.processWithSession called.");const t={statusMessage:constants_1.ZosApiMessages.listAllMembers.message,percentComplete:0,stageName:imperative_1.TaskStage.IN_PROGRESS};e.response.progress.startBar({task:t});const a=yield List_1.List.allMembers(s,e.arguments.dataSetName,{pattern:e.arguments.pattern});let n;a.apiResponse.items&&a.apiResponse.items.length>0&&(n=a.apiResponse.items.map(e=>e)),a.apiResponse.found&&a.apiResponse.found.length>0&&(n=a.apiResponse.found.map(e=>e.member));const r={items:n};return a.apiResponse=r,a.apiResponse.items?(e.response.data.setObj(a.apiResponse),e.response.data.setMessage(`Returned list of PDS Members "${e.arguments.dataSetName}"`),e.response.format.output({output:a.apiResponse.items,format:"list"})):e.response.console.log("No members found."),a}))}}exports.default=AllMembersHandler;