/*
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2020, 2021. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *
 */
import * as imperative from '@zowe/imperative';
import { ITokenInfo } from '../../../doc/ITokenInfo';
export declare class AuthLogin {
    static getToken(session: imperative.Session, commandParameters: imperative.IHandlerParameters, profile: imperative.IProfile): Promise<imperative.Session>;
    static validateToken(session: imperative.Session, tokenHeader?: {}): Promise<ITokenInfo>;
    static promptUserPass(session: imperative.Session): Promise<imperative.Session>;
    /**
     * Get Log
     * @returns {Logger} applicationLogger.
     */
    private static get log();
}
