/*
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2020, 2021. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *
 */
"use strict";var __awaiter=this&&this.__awaiter||function(s,e,t,r){return new(t||(t=Promise))((function(o,a){function i(s){try{p(r.next(s))}catch(s){a(s)}}function n(s){try{p(r.throw(s))}catch(s){a(s)}}function p(s){var e;s.done?o(s.value):(e=s.value,e instanceof t?e:new t((function(s){s(e)}))).then(i,n)}p((r=r.apply(s,e||[])).next())}))};Object.defineProperty(exports,"__esModule",{value:!0}),exports.ChangePassword=void 0;const imperative_1=require("@zowe/imperative"),constants_1=require("../../constants"),rest_1=require("../../rest"),CoreUtils_1=require("../../utils/CoreUtils");class ChangePassword{static setNewPassword(s,e,t,r,o){return __awaiter(this,void 0,void 0,(function*(){this.log.trace("ChangePassword.setNewPassword called"),imperative_1.ImperativeExpect.toNotBeNullOrUndefined(r,constants_1.ZosApiMessages.missingNewPassword.message),imperative_1.ImperativeExpect.toNotBeNullOrUndefined(t,constants_1.ZosApiMessages.missingCurrentPassword.message),imperative_1.ImperativeExpect.toNotBeNullOrUndefined(s,constants_1.ZosFilesMessages.missingSession.message);if(0!==t.localeCompare(s.ISession.password))throw this.log.error(constants_1.ZosApiMessages.currentPasswordValues.message),new imperative_1.ImperativeError({msg:constants_1.ZosApiMessages.currentPasswordValues.message});if(0===t.localeCompare(r))throw this.log.error(constants_1.ZosApiMessages.identicalPasswordValues.message),new imperative_1.ImperativeError({msg:constants_1.ZosApiMessages.identicalPasswordValues.message});if(r.length>8)throw this.log.error(constants_1.ZosApiMessages.passwordLength.message),new imperative_1.ImperativeError({msg:constants_1.ZosApiMessages.passwordLength.message});yield CoreUtils_1.apiVersionCheck(s,102);const a=`${constants_1.ZosRestApiConstants.RESOURCE}${constants_1.ZosRestApiConstants.AUTHLOGIN}`;this.log.debug("Endpoint: "+a);const i={userid:s.ISession.user.toUpperCase(),password:t.toUpperCase(),newpassword:r.toUpperCase()};try{const t=yield rest_1.RseRestClient.postExpectJSON(s,a,[],i);return e.password&&null===t&&(e.password=r,yield CoreUtils_1.updateYaml(o,e)),{success:!0,commandResponse:null,apiResponse:t}}catch(s){const e=s;throw e.toString().includes("401")?(this.log.error(constants_1.ZosApiMessages.invalidCreds.message),new imperative_1.ImperativeError({msg:constants_1.ZosApiMessages.invalidCreds.message})):(this.log.error(e.message.toString()),e.message)}}))}static get log(){return imperative_1.Logger.getAppLogger()}}exports.ChangePassword=ChangePassword;