/*
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2020, 2021. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *
 */
import { Session } from '@zowe/imperative';
import { IRestApiResponse } from '../../doc/IRestApiResponse';
export declare class CheckAddressSpace {
    static getSystemInfo(session: Session): Promise<IRestApiResponse>;
    static getJobsInfo(session: Session): Promise<IRestApiResponse>;
    private static zosExplVersionCheck;
    /**
     * Get Log
     * @returns {Logger} applicationLogger.
     */
    private static get log();
}
