/*
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2020, 2021. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *
 */
"use strict";var __awaiter=this&&this.__awaiter||function(t,e,s,n){return new(s||(s=Promise))((function(o,r){function i(t){try{c(n.next(t))}catch(t){r(t)}}function a(t){try{c(n.throw(t))}catch(t){r(t)}}function c(t){var e;t.done?o(t.value):(e=t.value,e instanceof s?e:new s((function(t){t(e)}))).then(i,a)}c((n=n.apply(t,e||[])).next())}))};Object.defineProperty(exports,"__esModule",{value:!0}),exports.Rename=void 0;const imperative_1=require("@zowe/imperative"),path_1=require("path"),rest_1=require("../../rest"),constants_1=require("../../constants"),CoreUtils_1=require("../../utils/CoreUtils"),constants_2=require("../../constants");class Rename{static uss(t,e,s){return __awaiter(this,void 0,void 0,(function*(){this.log.trace("Rename.uss called.");const n="/"+e,o=path_1.posix.join(constants_1.ZosRestApiConstants.RESOURCE,constants_1.ZosRestApiConstants.USS_FILES,n,constants_1.ZosRestApiConstants.RENAME,s);this.log.debug("Running RSE call "+o);const r=CoreUtils_1.setHeaders(t);try{return{success:!0,commandResponse:null,apiResponse:yield rest_1.RseRestClient.postExpectJSON(t,o,r)}}catch(t){const e=t;throw this.log.error(e.toString()),t}}))}static dataSet(t,e,s){return __awaiter(this,void 0,void 0,(function*(){this.log.trace("Rename.dataSet called.");let n=path_1.posix.join(constants_1.ZosRestApiConstants.RESOURCE,constants_1.ZosRestApiConstants.DATASETS,e.toUpperCase(),constants_1.ZosRestApiConstants.RENAME);n+=s.toUpperCase(),this.log.debug("Running RSE call "+n);const o=CoreUtils_1.setHeaders(t);try{return{success:!0,commandResponse:null,apiResponse:yield rest_1.RseRestClient.postExpectJSON(t,n,o)}}catch(t){const e=t;throw e.toString().includes("FORBIDDEN")?(this.log.error(constants_2.ZosFilesMessages.renameForbidden.message),new imperative_1.ImperativeError({msg:constants_2.ZosFilesMessages.renameForbidden.message})):(this.log.error(e.toString()),t)}}))}static get log(){return imperative_1.Logger.getAppLogger()}}exports.Rename=Rename;