/*
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2020, 2021. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *
 */
"use strict";var __awaiter=this&&this.__awaiter||function(e,s,t,o){return new(t||(t=Promise))((function(n,a){function i(e){try{c(o.next(e))}catch(e){a(e)}}function r(e){try{c(o.throw(e))}catch(e){a(e)}}function c(e){var s;e.done?n(e.value):(s=e.value,s instanceof t?s:new t((function(e){e(s)}))).then(i,r)}c((o=o.apply(e,s||[])).next())}))};Object.defineProperty(exports,"__esModule",{value:!0});const imperative_1=require("@zowe/imperative"),methods_1=require("../../../api/methods"),RestBaseHandler_1=require("../../RestBaseHandler"),CheckMappings_1=require("../../../api/methods/check/CheckMappings"),api_1=require("../../../api");class CheckStatusHandler extends RestBaseHandler_1.RestBaseHandler{processWithSession(e,s){return __awaiter(this,void 0,void 0,(function*(){const t={percentComplete:0,statusMessage:"Checking System Status...",stageName:imperative_1.TaskStage.IN_PROGRESS};e.response.progress.startBar({task:t});const o=yield methods_1.CheckStatus.getRseStatus(s);if(JSON.stringify(o).includes("stdout")){const s="Connected to the RSE API.";return e.response.data.setObj(o),e.response.format.output({output:s,format:"string"}),{success:!0,commandResponse:null,apiResponse:o}}let n;e.response.data.setObj(o),e.response.format.output({output:o,format:"object"});try{yield api_1.apiVersionCheck(s,api_1.RseApiVersionConstants.V103),n=!0}catch(e){n=!1}const a=CheckMappings_1.CheckMappings.mappingFileExist();if(!a&&n)e.response.console.log('Local MVS Mappings file not found.  To download the file issue command "zowe rse check maps".');else if(a&&n){0!==(yield CheckMappings_1.CheckMappings.compareMappingsFile(s))&&n&&(e.response.console.log("Local MVS Mappings file does not match Mappings file on the host."),e.response.console.log('Issue the command "zowe rse check maps" to download new copy to review changes or add the "--force" tag to the command to overwrite the local copy.'))}return{success:!0,commandResponse:null,apiResponse:o}}))}}exports.default=CheckStatusHandler;